"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const request = require("request-promise");
const interfaces_1 = require("./interfaces");
function buildUrl(type, category, subcategory) {
    return `https://burghquayregistrationoffice.inis.gov.ie/Website/AMSREG/AMSRegWeb.nsf/(getAppsNear)?openpage&cat=${category}&sbcat=${subcategory}&typ=${type}&_=1507583431263`;
}
function checkSlotsAvailability(type = interfaces_1.Types.New, category = interfaces_1.Categories.Work, subcategory = interfaces_1.Subcategories.All) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const response = yield request({
                url: buildUrl(type, category, subcategory),
                ciphers: 'DES-CBC3-SHA',
                rejectUnauthorized: false
            });
            return {
                status: 'success',
                data: JSON.parse(response)
            };
        }
        catch (error) {
            return {
                status: 'error',
                error
            };
        }
    });
}
exports.checkSlotsAvailability = checkSlotsAvailability;
